#ifndef BELLBRIAR_COMMON
#define BELLBRIAR_COMMON
#include "eeconfig.h"
#include "action_layer.h"
extern keymap_config_t keymap_config;

//#ifdef UNICODE_ENABLE
// Unicode shortcuts

// lowercase greek
#define alpha   X(0x03B1)
#define beta    X(0x03B2)
#define gamma   X(0x03B3)
#define delta   X(0x03B4)
#define epsilon X(0x03B5)
#define zeta    X(0x03B6)
#define eta     X(0x03B7)
#define theta   X(0x03B8)
#define iota    X(0x03B9)
#define kappa   X(0x03BA)
#define lambda  X(0x03BB)
#define mu      X(0x03BC)
#define nu      X(0x03BD)
#define xi      X(0x03BE)
#define omicron X(0x03BF)
#define pi      X(0x03C0)
#define rho     X(0x03C1)
#define sigma   X(0x03C3)
#define tau     X(0x03C4)
#define upsilon X(0x03C5)
#define phi     X(0x03C6)
#define chi     X(0x03C7)
#define psi     X(0x03C8)
#define omega   X(0x03C9)

// uppercase greek
#define ALPHA   X(0x0391)
#define BETA    X(0x0392)
#define GAMMA   X(0x0393)
#define DELTA   X(0x0394)
#define EPSILON X(0x0395)
#define ZETA    X(0x0396)
#define ETA     X(0x0397)
#define THETA   X(0x0398)
#define IOTA    X(0x0399)
#define KAPPA   X(0x039A)
#define LAMBDA  X(0x039B)
#define MU      X(0x039C)
#define NU      X(0x039D)
#define XI      X(0x039E)
#define OMICRON X(0x039F)
#define PI      X(0x03A0)
#define RHO     X(0x03A1)
#define SIGMA   X(0x03A3)
#define TAU     X(0x03A4)
#define UPSILON X(0x03A5)
#define PHI     X(0x03A6)
#define CHI     X(0x03A7)
#define PSI     X(0x03A8)
#define OMEGA   X(0x03A9)

// math symobols
#define DEGREE  X(0x00B0) // ^deg
#define PLUSMIN X(0x00B1)
#define SUPA2   X(0x00B2) // ^2
#define SUPA3   X(0x00B3) // ^3
#define VQUARTR X(0x00BC) // 1/4
#define VHALF   X(0x00BD) // 1/2
#define VTHREEQ X(0x00BE) // 3/4
#define SECTION X(0x00A7)
#define DAGGER  X(0x2021)
#define DDAGGER X(0x2022)
#define MULTIPL X(0x00D7) // cross operator / multiplication
#define DIVISIN X(0x00F7)
#define DOT     X(0x2219) // dot opperator / bullet
#define INFINIT X(0x221E) // infinity
#define PROPORT X(0x221D) // proportionality
#define NUMERO  X(0x2116)
#define ROOT2   X(0x221A) // square root
#define ROOT3   X(0x221B)
#define INT1    X(0x222B) // line integral
#define INT2    X(0x222C) // surface integral
#define INT3    X(0x222D) // volume integral
#define CINT1   X(0x222E) // contour line integral
#define CINT2   X(0x222E) // contour surface integral
#define CINT3   X(0x222E) // contour volume integral
#define LTEQ	X(0x2264) // less than or equal to
#define GTEQ    X(0x2265) // greather than or equal to
#define NOTEQ	X(0x2260) // not equal to
#define IDENT   X(0x2261) // triple bar, identity, definition
#define APPROX  X(0x2248) // approximatly equal to
#define ASYMEQ  X(0x2243) // asymptotic equality
#define ALLEQ   X(0x224C) // all equal to, isomorphism or congruence
#define NABLA   X(0x2207) // gradient, w/dot divergence, w/cross curl

// astrological symobols
#define SUN     X(0x2609)
#define MOON    X(0x263D)
#define MERCURY X(0x263F)
#define VENUS   X(0x2640)
#define EARTH   X(0x2295)
#define MARS    X(0x2642)
#define JUPITER X(0x2643)
#define SATURN  X(0x2644)
#define URANUS  X(0x2645)
#define NEPTUNE X(0x2646)
#define CERES   X(0x26B3)
#define PALLAS  X(0x26B4)
#define JUNO    X(0x26B5)
#define VESTA   X(0x26B6)
#define HYGIEA  X(0x2695)
#define CHIRON  X(0x26B7)
#define ERIS    X(0x2641) // 0478
#define LILITH  X(0x26B8)
#define PLUTO   X(0x2647)
#define ANODE   X(0x260A) // ascending node
#define DNODE   X(0x260B) // decending node
#define COMET   X(0x2604)

#define SKULLX  X(0x2620)
#define RADIATN X(0x2622)
#define BIOHAZ  X(0x2623)
#define WARNING X(0x26A1)
#define ATOM    X(0x269B)
#define RECYCLE X(0x267B)

#ifdef UNICODEMAP_ENABLE        // For Unicode characters larger than 0x8000. Send with X(<unicode>)
enum Ext_Unicode{
    PENGUIN = 0,
    BOAR,
    MONKEY,
    DRAGON,
    CHICK,
    TUMBLER
};
const uint32_t PROGMEM unicode_map[] = {
    [PENGUIN]   = 0x1F427,
    [BOAR]      = 0x1F417,
    [MONKEY]    = 0x1F412,
    [DRAGON]    = 0x1F409,
    [CHICK]     = 0x1F425,
    [TUMBLER]   = 0x1F943
};
#define PENGY   X(PENGUIN)
#define BOARY   X(BOAR)
#define MNKY    X(MONKEY)
#define DRGN    X(DRAGON)
#define DUCK    X(CHICK)
#define TMBL    X(TUMBLER)
#endif

//#endif

  switch (keycode) {
    case SHFT_CAP:
        if(record->event.pressed){
            key_timer = timer_read();               // if the key is being pressed, we start the timer.
            register_code(KC_LSHIFT);
        } else {                                    // this means the key was just released (tap or "held down")
            if(timer_elapsed(key_timer) < 152){     // Time in ms, the threshold we pick for counting something as a tap.
                tap(KC_CAPS);
                if(caps_status == 0){
                    caps_status = 1;
                } else {
                    caps_status = 0;
                }
            }
            unregister_code(KC_LSHIFT);
        }
        return false;
        break;
    #ifdef UNICODE_ENABLE
    case DISFACE:       // ಠ_ಠ
        if(record->event.pressed){
            process_unicode((0x0CA0|QK_UNICODE), record);   // Eye
            register_code(KC_RSFT);
            tap(KC_MINS);
            unregister_code(KC_RSFT);
            process_unicode((0x0CA0|QK_UNICODE), record);   // Eye
        }
        return false;
        break;
    case TFLIP:         // (╯°□°)╯ ︵ ┻━┻
        if(record->event.pressed){
            register_code(KC_RSFT);
            tap(KC_9);
            unregister_code(KC_RSFT);
            process_unicode((0x256F|QK_UNICODE), record);   // Arm
            process_unicode((0x00B0|QK_UNICODE), record);   // Eye
            process_unicode((0x25A1|QK_UNICODE), record);   // Mouth
            process_unicode((0x00B0|QK_UNICODE), record);   // Eye
            register_code(KC_RSFT);
            tap(KC_0);
            unregister_code(KC_RSFT);
            process_unicode((0x256F|QK_UNICODE), record);   // Arm
            tap(KC_SPC);
            process_unicode((0x0361|QK_UNICODE), record);   // Flippy
            tap(KC_SPC);
            process_unicode((0x253B|QK_UNICODE), record);   // Table
            process_unicode((0x2501|QK_UNICODE), record);   // Table
            process_unicode((0x253B|QK_UNICODE), record);   // Table
        }
        return false;
        break;
    case SHRUG:         // ¯\_(ツ)_/¯
        if(record->event.pressed){
            process_unicode((0x00AF|QK_UNICODE), record);   // Hand
            tap(KC_BSLS);                                   // Arm
            register_code(KC_RSFT);
            tap(KC_UNDS);                                   // Arm
            tap(KC_LPRN);                                   // Head
            unregister_code(KC_RSFT);
            process_unicode((0x30C4|QK_UNICODE), record);   // Face
            register_code(KC_RSFT);
            tap(KC_RPRN);                                   // Head
            tap(KC_UNDS);                                   // Arm
            unregister_code(KC_RSFT);
            tap(KC_SLSH);                                   // Arm
            process_unicode((0x00AF|QK_UNICODE), record);   // Hand
        }
        return false;
        break;
    #endif
    case RANDIG:
        if (record->event.pressed) {
            tap_random_base64();
        }
        return false;
        break;
  }
  return true;
}
#endif
